﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data.Linq;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Web.Services;
using System.Net;
using System.Xml;
using System.Xml.Linq;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;


// https://maila23.webcontrolcenter.com/Services/svcNotifications.asmx?wsdl
// http://216.119.89.178/A2ZCommunityWS/GetURL.asmx
// java
// http://eweb.co.yavapai.az.us/recorder/services/Security.wsdl

// read over this for help http://stackoverflow.com/questions/3821262/linq-2-xml-how-to-retrieve-web-methods-names-from-a-wsdl-document && http://tech.pro/tutorial/743/introduction-to-linq-simple-xml-parsing

// http://www.codeproject.com/Articles/18950/Dynamic-Discovery-and-Invocation-of-Web-Services
// http://www.west-wind.com/presentations/dotnetWebRequest/dotnetWebRequest.htm

namespace WebServicesFuzzer
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }
        WebServiceInvoker invoker;

        public void dothingsfast()
        {

        }
        private void btnLookupServices_Click(object sender, EventArgs e)
        {

            bgw.RunWorkerAsync();
            
        }
        public string GetWebData(string url) 
        {
            if (!url.EndsWith("asmx"))
            {
                url += "?wsdl";
            }
            System.Net.WebClient myWebClient = new System.Net.WebClient();
            WebProxy myProxy = new WebProxy();
            myProxy.IsBypassed(new Uri(url));
            myWebClient.Proxy = myProxy;
            return myWebClient.DownloadString(url);
        }
   
        public void PopThemFields()
        {
            this.tbFields2Hit.Enabled = true;
            this.rbBoth.Enabled = true;
            this.rbNumeric.Enabled = true;
            this.rbText.Enabled = true;
            this.btnStart.Enabled = true;
            this.btnStop.Enabled = true;
        }
       
        private void btnStart_Click(object sender, EventArgs e)
        {
            TaskFactory tfc = new TaskFactory();
            //http://stackoverflow.com/questions/10313185/dynamically-create-thread
            //http://stackoverflow.com/questions/4619874/dynamic-thread-and-label-creation
            //http://stackoverflow.com/questions/10969381/generate-new-threads-dynamically-using-c-sharp-net'
            //http://msdn.microsoft.com/en-us/library/ee256691.aspx
            /*
             Fuzz(int type, int con)
            {
            switch(type)
            {
	        case 1:{ // type for numeric
		        for(int x=0x>con;x++){
		        Task.Factory.StartNew(() => {code to start smacking shit with numbers}
	            }
	        case 2:{ // type for text
		    for(int x=0x>con;x++){
		    Task.Factory.StartNew(() => {code to start smacking shit with text}
	        }
	        case 1:{ // type for both
		for(int x=0x>con;x++){
		  Task.Factory.StartNew(() => {code to start smacking shit with both text and numbers}
	       }
            }
            }
             */



            int numofthreads = tbConnections.Value;
            if (rbText.Checked)
            {
                TheFuzz(1,numofthreads);
                return;
            }
            if (rbNumeric.Checked)
            {
                TheFuzz(2, numofthreads);
                return;
            }
            if (rbBoth.Checked)
            {
                TheFuzz(3, numofthreads);
                return;
            }
            MessageBox.Show("You need to select a type for me to fuzz properly!", "Error");
            
        }

        private void comboboxServices_SelectedIndexChanged(object sender, EventArgs e)
        {
             // load methods for selected service
            this.listBoxMethods.Items.Clear();

            List<string> methods = this.invoker.EnumerateServiceMethods(this.comboboxServices.SelectedItem as string);

            foreach (string method in methods)
                listBoxMethods.Items.Add(method);

            if (listBoxMethods.Items.Count > 0)
            {
                listBoxMethods.SelectedIndex = 0;
                btnStart.Enabled = true;
            }
            else
            {
                btnStart.Enabled = false;
            }
        
        }

        private bool IsItDotNet()
        {
            string url = tbHostName.Text;
            if (url.Contains(".asmx")) // .net 2, 3, 4 use asmx
            {
                return true;
            }
            if (url.Contains(".svc")) // .net 1.1 uses svc
            {
                return true;
            }
            return false;
        }

        private void listBoxMethods_DoubleClick(object sender, EventArgs e)
        {
            if (IsItDotNet())
            {
                try
                {

                    this.tbFields2Hit.Text += listBoxMethods.SelectedItem + ", ";
                    XDocument wsDoc = XDocument.Load(tbHostName.Text + "?wsdl");
                    XNamespace s = "http://www.w3.org/2001/XMLSchema";
                    XNamespace wsdl = "http://schemas.xmlsoap.org/wsdl/";
                    var schema = wsDoc.Root.Element(wsdl + "types").Element(s + "schema");

                    var elements = schema.Elements(s + "element");
                    Func<XElement, string> getName = (el) => el.Attribute("name").Value; // get method param name
                    Func<XElement, string> getType = (el) => el.Attribute("type").Value; // get method param type

                    string methodName = listBoxMethods.SelectedItem.ToString(); //  to be grabbed from other list box on double click

                    var method = elements
                        .Single(el => getName(el) == methodName);

                    // these are all parameters for a given method
                    var parameters = from par in method.Descendants(s + "element")
                                     select getName(par);
                    var parameters2 = from par2 in method.Descendants(s + "element")
                                      select getType(par2);


                    foreach (string record in parameters)
                    {
                        MethodArgsLB.Items.Add("For " + methodName + " - Parameter Name - " + record);
                    }
                    foreach (string record in parameters2)
                    {
                        MethodArgsLB.Items.Add("For " + methodName + " - Paramater Type - " + record);
                    }
                }
                catch (Exception lolwut)
                {
                    MessageBox.Show(lolwut.ToString());
                    return;
                }
            }
            else
            {
                MessageBox.Show("Sorry, java web services and .net dont mix D:");
            }
           

    
        }
        /*
        WebServiceInvoker invoker = new WebServiceInvoker(new Uri("http://localhost/services/test.php"));
        string service = “MyService”;
        string method = “MyMethod”;
        string[] args = new string[] { “arg1”, “arg2” };
        string result = invoker.InvokeMethod<string>(service, method, args);
         */
        public void TheFuzz(int type, int cons)
        {
            switch(type)
            {
                case 1:
                    {
                        try
                        {
                            // invoke the selected method on the selected service
                            string service = this.comboboxServices.SelectedItem as string;
                            string method = this.listBoxMethods.SelectedItem as string;
                            

                            string[] args = tbFields2Hit.Text.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);

                            string result = invoker.InvokeMethod<string>(service, method, args);
                            

                            tbResults.Text = result;
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Error Invoking Method: " + ex.Message,"Error!");
                        }
                        break;
                    }
                case 2:
                    {
                        try
                        {
                            // invoke the selected method on the selected service
                            string service = this.comboboxServices.SelectedItem as string;
                            string method = this.listBoxMethods.SelectedItem as string;

                            string[] args = tbFields2Hit.Text.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);

                            string result = invoker.InvokeMethod<string>(service, method, args);

                            tbResults.Text = result;
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Error Invoking Method: " + ex.Message, "Error!");
                        }
                        break;
                    }
                case 3:
                    {
                        try
                        {
                            // invoke the selected method on the selected service
                            string service = this.comboboxServices.SelectedItem as string;
                            string method = this.listBoxMethods.SelectedItem as string;

                            string[] args = tbFields2Hit.Text.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);

                            string result = invoker.InvokeMethod<string>(service, method, args);

                            tbResults.Text = result;
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Error Invoking Method: " + ex.Message, "Error!");
                        }
                        break;
                    }
           }
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            
            
        }

        private void tbConnections_Scroll(object sender, EventArgs e)
        {
            lblCon.Text = Convert.ToString(tbConnections.Value);
        }
        

        private void MainForm_Load(object sender, EventArgs e)
        {
            MainForm.CheckForIllegalCrossThreadCalls = false;
          
            /*
            string tst = "http://eweb.co.yavapai.az.us/recorder/services/Security.wsdl";
            XDocument doc = XDocument.Load(tst);
            XNamespace ns = "http://www.w3.org/2001/XMLSchema";

            var meths = from meth in doc.Descendants("message")
                       select new
                       {
                           thetype = meth.Element("part").Attribute("name").Value,

                       };

            foreach (var meth in meths)
            {
                MessageBox.Show(meth.thetype);
            }
            */

        }

        private void bgw_DoWork(object sender, DoWorkEventArgs e)
        {
            this.lblHostDiscoStatus.Text = "Discovering...";
            if (this.tbPort.Text != "80")
            {
                string url = this.tbHostName.Text + ":" + this.tbPort.Text;
                if (tbHostName.Text == "" || tbHostName.Text == "http://")
                {
                    MessageBox.Show("No host added, cant lookup!", "Error!");
                    return;
                }
                try
                {
                    // create service invoker from user string
                    invoker = new WebServiceInvoker(new Uri(url));

                    // populate services combobox
                    foreach (string service in invoker.AvailableServices)
                        comboboxServices.Items.Add(service);

                    // select first service
                    if (comboboxServices.Items.Count > 0)
                        comboboxServices.SelectedIndex = 0;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Unable To Load Service: " + ex.Message, "Error!");
                }
            }
            else
            {
                string url = this.tbHostName.Text;

                if (tbHostName.Text == "" || tbHostName.Text == "http://")
                {
                    MessageBox.Show("No host added, cant lookup!");
                    return;
                }
                try
                {
                    // create service invoker from user string
                    invoker = new WebServiceInvoker(new Uri(url));

                    // populate services combobox
                    foreach (string service in invoker.AvailableServices)
                    {
                        comboboxServices.Items.Add(service);
                    }

                    // select first service
                    if (comboboxServices.Items.Count > 0)
                    {
                        comboboxServices.SelectedIndex = 0;
                        PopThemFields();
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Unable To Load Service: " + ex.Message);
                }
                this.lblHostDiscoStatus.Text = "Completed!";

            }
        }
       
       
    }
    
}

/*
 * changed line to this: string[] references = new string[3] { “System.Web.Services.dll”, “System.Xml.dll” , “System.Data.dll”};
 * AUTH HERE:
 * 
public T InvokeMethod(string serviceName, string methodName, params object[] args)
{
// create an instance of the specified service
// and invoke the method
object obj = this.webServiceAssembly.CreateInstance(serviceName);

Type type = obj.GetType();
PropertyInfo propInfo = obj.GetType().GetProperty(“Credentials”);
propInfo.SetValue(obj, new NetworkCredential(userName,password,domain), null);
return (T)type.InvokeMember(methodName, BindingFlags.InvokeMethod, null, obj, args);
}
 */

/*
  var lol = new FunctionArgs();
  lol.Show();
  PassData2Form pas = new PassData2Form(lol.FunctionDatas);
  pas(GrepDatas(GetWebData(tbHostName.Text))); // downloads file name from host text box and stores it in the secondary form as html. 
 // the ?wsdl forces XML. java web services do this anyways, so...
 */
